% ROMER.M

% Bruce E. Hansen
% Department of Economics
% Social Science Building
% University of Wisconsin
% Madison, WI 53706-1393
% bhansen@ssc.wisc.edu
% http://www.ssc.wisc.edu/~bhansen/

% This GAUSS program replicates Table 2 from Hansen,
% Journal of Policy Modeling, 1992.
function romer();
load romerdata.txt;
x=romerdata;
t1=1869;
t2=1987;
x=x(2:length(x))-x(1:length(x)-1);

xt=(t1+1:t2)';
sel=(xt<=1987).*(xt>=1889);
ind=0;
for ii=1:length(sel)
    if sel(ii)==1
        if ind==0
            temp=x(ii,:);
            ind=1;
        else
            temp=[temp;x(ii,:)];
        end;
    end;
end;
x1=temp;
sel=(xt<=1929).*(xt>=1889);
ind=0;
for ii=1:length(sel)
    if sel(ii)==1
        if ind==0
            temp=x(ii,:);
            ind=1;
        else
            temp=[temp;x(ii,:)];
        end;
    end;
end;
x2=temp;
sel=(xt<=1947).*(xt>=1930);
ind=0;
for ii=1:length(sel)
    if sel(ii)==1
        if ind==0
            temp=x(ii,:);
            ind=1;
        else
            temp=[temp;x(ii,:)];
        end;
    end;
end;
x3=temp;
sel=(xt<=1987).*(xt>=1948);
ind=0;
for ii=1:length(sel)
    if sel(ii)==1
        if ind==0
            temp=x(ii,:);
            ind=1;
        else
            temp=[temp;x(ii,:)];
        end;
    end;
end;
x4=temp;
n1=length(x1(:,1));
n2=length(x2(:,1));
n3=length(x3(:,1));
n4=length(x4(:,1));
dat1=[x1(2:n1),ones(n1-1,1),x1(1:n1-1)];
dat2=[x2(2:n2),ones(n2-1,1),x2(1:n2-1)];
dat3=[x3(2:n3),ones(n3-1,1),x3(1:n3-1)];
dat4=[x4(2:n4),ones(n4-1,1),x4(1:n4-1)];

datnames=['______DY';'Constant';'__DY(-1)'];


fprintf('Sample: 1889 to 1987\n');
lc(dat1,datnames);

fprintf('Sample: 1889 to 1929\n');
lc(dat2,datnames);

fprintf('Sample: 1930 to 1947\n');
lc(dat3,datnames);

fprintf('Sample: 1948 to 1987\n');
lc(dat4,datnames);
